=== modified file 'NEWS'
--- NEWS	2005-03-29 06:02:14 +0000
+++ NEWS	2005-03-29 06:25:15 +0000
@@ -18,7 +18,9 @@
       'deleted' lists files deleted in the current working tree.
 
     * Performance improvements.
-
+
+    * New global --profile option.
+    
 bzr-0.0.1  2005-03-26
 
   ENHANCEMENTS:

=== modified file 'bzrlib/commands.py'
--- bzrlib/commands.py	2005-03-29 06:10:25 +0000
+++ bzrlib/commands.py	2005-03-29 06:25:15 +0000
@@ -604,6 +604,7 @@
     'all':                    None,
     'help':                   None,
     'message':                unicode,
+    'profile':                None,
     'revision':               int,
     'show-ids':               None,
     'timezone':               str,
@@ -793,7 +794,12 @@
     except KeyError:
         bailout("unknown command " + `cmd`)
 
-    # TODO: special --profile option to turn on the Python profiler
+    # global option
+    if 'profile' in opts:
+        profile = True
+        del opts['profile']
+    else:
+        profile = False
 
     # check options are reasonable
     allowed = cmd_options.get(cmd, [])
@@ -802,11 +808,24 @@
             bailout("option %r is not allowed for command %r"
                     % (oname, cmd))
 
+    # mix arguments and options into one dictionary
     cmdargs = _match_args(cmd, args)
     for k, v in opts.items():
         cmdargs[k.replace('-', '_')] = v
 
-    ret = cmd_handler(**cmdargs) or 0
+    if profile:
+        import hotshot
+        prof = hotshot.Profile('.bzr.profile')
+        ret = prof.runcall(cmd_handler, **cmdargs) or 0
+        prof.close()
+
+        import hotshot.stats
+        stats = hotshot.stats.load('.bzr.profile')
+        #stats.strip_dirs()
+        stats.sort_stats('cumulative', 'calls')
+        stats.print_stats(20)
+    else:
+        return cmd_handler(**cmdargs) or 0
 
 
 

